=== debian/changelog ===
libdeflate (1.23-2) unstable; urgency=low

  * d/control: use my @debian.org email address
  * d/copyright: add me and Nick to the debian/* stanza
  * d/control: declare dpkg-build-api = 1

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 09 Apr 2025 18:18:12 +0200

libdeflate (1.23-1) unstable; urgency=medium

  * New upstream 1.23.

 -- nick black <dankamongmen@gmail.com>  Tue, 14 Jan 2025 09:45:40 -0500
