=== debian/control ===
Source: libdeflate
Maintainer: Deflate Team <libdeflate@packages.debian.org>
Uploaders: Nick Black <dankamongmen@gmail.com>,
           Andrea Pappacoda <tachi@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dpkg-build-api (= 1),
               cmake,
               zlib1g-dev <!nocheck>,
               python3 <!nocheck>,
               xxd <!nocheck>,
               help2man <!nodoc> <!cross>
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
Homepage: https://github.com/ebiggers/libdeflate

Package: libdeflate0
Multi-Arch: same
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: fast, whole-buffer DEFLATE-based compression and decompression
 The supported formats are:
  * DEFLATE (raw)
  * zlib (a.k.a. DEFLATE with a zlib wrapper)
  * gzip (a.k.a. DEFLATE with a gzip wrapper)
 .
 libdeflate is heavily optimized. It is significantly faster than the zlib
 library, both for compression and decompression, and especially on x86
 processors. In addition, libdeflate provides optional high compression modes
 that provide a better compression ratio than the zlib's "level 9".

Package: libdeflate-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdeflate0 (= ${binary:Version}),
         ${misc:Depends}
Description: headers for whole-buffer compression and decompression library
 The supported formats are:
  * DEFLATE (raw)
  * zlib (a.k.a. DEFLATE with a zlib wrapper)
  * gzip (a.k.a. DEFLATE with a gzip wrapper)
 .
 libdeflate is heavily optimized. It is significantly faster than the zlib
 library, both for compression and decompression, and especially on x86
 processors. In addition, libdeflate provides optional high compression modes
 that provide a better compression ratio than the zlib's "level 9".
 .
 This package provides the development headers.

Package: libdeflate-tools
Architecture: any
Section: utils
Depends: libdeflate0 (= ${binary:Version}),
         ${misc:Depends}, ${shlibs:Depends}
Description: tools for whole-buffer compression and decompression library
 The supported formats are:
  * DEFLATE (raw)
  * zlib (a.k.a. DEFLATE with a zlib wrapper)
  * gzip (a.k.a. DEFLATE with a gzip wrapper)
 .
 libdeflate is heavily optimized. It is significantly faster than the zlib
 library, both for compression and decompression, and especially on x86
 processors. In addition, libdeflate provides optional high compression modes
 that provide a better compression ratio than the zlib's "level 9".
 .
 This package provides the sample tool: libdeflate-gzip (and libdeflate-gunzip).
 This program which can be a drop-in replacement for standard "gzip" under
 some circumstances.  Note that "libdeflate-gzip" has some  limitations; it is
 provided for convenience and is **not** meant to be the main use case of
 libdeflate.  It needs a lot of memory to process large files, and it omits
 support for some infrequently-used options of GNU gzip.
