=== debian/tests/control ===
Tests: sample-programs
Depends: @, bash
