## libdeflate 1.23.0

=== DESCRIPTION ===
Package: libdeflate
Type: Package
Title: DEFLATE Compression Static Library and Headers
Version: 1.23.0
Authors@R: 
    c(
      person(
        "Tyler", "Morgan-Wall",
        email = "tylermw@gmail.com",
        role = c("aut", "cre"),
        comment = c(ORCID = "0000-0002-3131-3814")
      ),
      person(
        "Eric", "Biggers",
        role = c("aut", "cph")
      ),
      person("Google LLC", role = "cph"),
      person(
        "Kevin", "Ushey",
        role = c("cph")
      )
    )
Description: Provides the 'libdeflate' static library 
    (see <https://github.com/ebiggers/libdeflate>) and 'C' headers for 
    whole-buffer DEFLATE-based compression and decompression, along with
    an R interface for compressing and decompressing raw vectors.
Depends: R (>= 3.5.0)
License: MIT + file LICENSE
Encoding: UTF-8
SystemRequirements: GNU make, CMake
RoxygenNote: 7.3.2
Config/build/compilation-database: true
BugReports: https://github.com/tylermorganwall/libdeflate/issues
NeedsCompilation: yes
Packaged: 2025-05-06 01:24:01 UTC; tyler
Author: Tyler Morgan-Wall [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3131-3814>),
  Eric Biggers [aut, cph],
  Google LLC [cph],
  Kevin Ushey [cph]
Maintainer: Tyler Morgan-Wall <tylermw@gmail.com>
Repository: CRAN
Date/Publication: 2025-05-07 13:50:02 UTC
