## libdeflate 1.24-0

=== DESCRIPTION ===
Package: libdeflate
Type: Package
Title: DEFLATE Compression and Static Library
Version: 1.24-0
Authors@R: 
    c(
      person(
        "Tyler", "Morgan-Wall",
        email = "tylermw@gmail.com",
        role = c("aut", "cre"),
        comment = c(ORCID = "0000-0002-3131-3814")
      ),
      person(
        "Eric", "Biggers",
        role = c("aut", "cph")
      ),
      person("Google LLC", role = "cph"),
      person(
        "Kevin", "Ushey",
        role = c("cph")
      )
    )
Description: Whole-buffer DEFLATE-based compression and 
    decompression of raw vectors using the 'libdeflate' library 
    (see <https://github.com/ebiggers/libdeflate>). Provides the user with additional 
    control over the speed and the quality of DEFLATE compression 
	compared to the fixed level of compression offered in R's 
    'memCompress()' function. Also provides the 'libdeflate' static library and 
    'C' headers along with a 'CMake' target and 'package‑config' file that 
    ease linking of 'libdeflate' in packages that compile and statically link 
    bundled libraries using 'CMake'.
Depends: R (>= 3.5.0)
License: MIT + file LICENSE
Encoding: UTF-8
SystemRequirements: GNU make, CMake
RoxygenNote: 7.3.2
Config/build/compilation-database: true
BugReports: https://github.com/tylermorganwall/libdeflate/issues
NeedsCompilation: yes
Packaged: 2025-05-23 21:42:21 UTC; tyler
Author: Tyler Morgan-Wall [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3131-3814>),
  Eric Biggers [aut, cph],
  Google LLC [cph],
  Kevin Ushey [cph]
Maintainer: Tyler Morgan-Wall <tylermw@gmail.com>
Repository: CRAN
Date/Publication: 2025-05-27 09:10:09 UTC
