## libdeflate 1.24-2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: libdeflate
 Type: Package
 Title: DEFLATE Compression and Static Library
-Version: 1.24-0
+Version: 1.24-2
 Authors@R: 
     c(
       person(
@@ -24,7 +24,7 @@
     decompression of raw vectors using the 'libdeflate' library 
     (see <https://github.com/ebiggers/libdeflate>). Provides the user with additional 
     control over the speed and the quality of DEFLATE compression 
-	compared to the fixed level of compression offered in R's 
+    compared to the fixed level of compression offered in R's 
     'memCompress()' function. Also provides the 'libdeflate' static library and 
     'C' headers along with a 'CMake' target and 'package‑config' file that 
     ease linking of 'libdeflate' in packages that compile and statically link 
@@ -37,7 +37,7 @@
 Config/build/compilation-database: true
 BugReports: https://github.com/tylermorganwall/libdeflate/issues
 NeedsCompilation: yes
-Packaged: 2025-05-23 21:42:21 UTC; tyler
+Packaged: 2025-06-24 02:47:51 UTC; tyler
 Author: Tyler Morgan-Wall [aut, cre] (ORCID:
     <https://orcid.org/0000-0002-3131-3814>),
   Eric Biggers [aut, cph],
@@ -45,4 +45,4 @@
   Kevin Ushey [cph]
 Maintainer: Tyler Morgan-Wall <tylermw@gmail.com>
 Repository: CRAN
-Date/Publication: 2025-05-27 09:10:09 UTC
+Date/Publication: 2025-06-24 08:00:07 UTC
