## libdeflate 1.24-7

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: libdeflate
 Type: Package
 Title: DEFLATE Compression and Static Library
-Version: 1.24-4
+Version: 1.24-7
 Authors@R: 
     c(
       person(
@@ -37,7 +37,7 @@
 Config/build/compilation-database: true
 BugReports: https://github.com/tylermorganwall/libdeflate/issues
 NeedsCompilation: yes
-Packaged: 2025-06-28 18:59:19 UTC; tyler
+Packaged: 2025-07-17 02:06:33 UTC; tyler
 Author: Tyler Morgan-Wall [aut, cre] (ORCID:
     <https://orcid.org/0000-0002-3131-3814>),
   Eric Biggers [aut, cph],
@@ -45,4 +45,4 @@
   Kevin Ushey [cph]
 Maintainer: Tyler Morgan-Wall <tylermw@gmail.com>
 Repository: CRAN
-Date/Publication: 2025-06-29 14:20:02 UTC
+Date/Publication: 2025-07-21 13:51:57 UTC
